IO::IOHandlerImpl Class Referenceabstract

This class contains a minimum level of functionality that makes it more convenient to derive from than IOHandler. More...

`#include <IOHandlerImpl.h>`

Inheritance diagram for IO::IOHandlerImpl:

## Protected Member Functions

| IOHandlerImpl (const char *formatName, const char *formatDescription)
void | registerInput (const DataType &type)
| Specify that input of the argument type is supported.
void | registerOutput (const DataType &type)
| Specify that output of the argument type is supported.

## Private Member Functions

virtual BigTermConsumer * | doCreateIdealWriter (FILE *out)=0
virtual CoefBigTermConsumer * | doCreatePolynomialWriter (FILE *out)
virtual void | doReadTerm (Scanner &in, InputConsumer &term)
virtual void | doReadIdeal (Scanner &in, InputConsumer &consumer)
virtual void | doReadIdeals (Scanner &in, InputConsumer &consumer)
virtual void | doReadPolynomial (Scanner &in, CoefBigTermConsumer &consumer)
virtual void | doReadSatBinomIdeal (Scanner &in, SatBinomConsumer &consumer)
virtual const char * | doGetName () const
virtual const char * | doGetDescription () const
virtual bool | doSupportsInput (const DataType &type) const
virtual bool | doSupportsOutput (const DataType &type) const
virtual bool | doHasMoreInput (Scanner &in) const

## Private Attributes

vector< const DataType * > | _supportedInputs
vector< const DataType * > | _supportedOutputs
const char * | _formatName
const char * | _formatDescription

## Additional Inherited Members

Public Member Functions inherited from IOHandler
virtual | ~IOHandler ()
void | readIdeal (Scanner &in, InputConsumer &consumer)
| Read an ideal and feed it to the consumer.
void | readIdeals (Scanner &in, InputConsumer &consumer)
| Read a number of ideals and feed them to the consumer.
void | readTerm (Scanner &in, const VarNames &names, vector< mpz_class > &term)
void | readPolynomial (Scanner &in, CoefBigTermConsumer &consumer)
void | readSatBinomIdeal (Scanner &in, SatBinomConsumer &consumer)
void | writeTerm (const vector< mpz_class > &term, const VarNames &names, FILE *out)
bool | hasMoreInput (Scanner &in) const
const char * | getName () const
const char * | getDescription () const
unique_ptr< BigTermConsumer > | createIdealWriter (FILE *out)
unique_ptr< BigTermConsumer > | createIdealListWriter (FILE *out)
unique_ptr< CoefBigTermConsumer > | createPolynomialWriter (FILE *out)
bool | supportsInput (const DataType &type) const
bool | supportsOutput (const DataType &type) const

## Detailed Description

This class contains a minimum level of functionality that makes it more convenient to derive from than IOHandler.

Definition at line 37 of file IOHandlerImpl.h.

## Constructor & Destructor Documentation

## IOHandlerImpl()

IO::IOHandlerImpl::IOHandlerImpl | ( | const char * | formatName,
|  | const char * | formatDescription )

protected

Definition at line 36 of file IOHandlerImpl.cpp.

## Member Function Documentation

## doCreateIdealWriter()

BigTermConsumer * IO::IOHandlerImpl::doCreateIdealWriter | ( | FILE * | out | ) |

private pure virtual

Implements IOHandler.

Implemented in IO::CoCoA4IOHandler, IO::CountingIOHandler, IO::Fourti2IOHandler, IO::Macaulay2IOHandler, IO::MonosIOHandler, IO::NewMonosIOHandler, IO::NullIOHandler, and IO::SingularIOHandler.

Definition at line 42 of file IOHandlerImpl.cpp.

## doCreatePolynomialWriter()

CoefBigTermConsumer * IO::IOHandlerImpl::doCreatePolynomialWriter | ( | FILE * | out | ) |

private virtual

Implements IOHandler.

Reimplemented in IO::CoCoA4IOHandler, IO::CountingIOHandler, IO::Fourti2IOHandler, IO::Macaulay2IOHandler, IO::NullIOHandler, and IO::SingularIOHandler.

Definition at line 46 of file IOHandlerImpl.cpp.

## doGetDescription()

const char * IO::IOHandlerImpl::doGetDescription | ( |  | ) | const

private virtual

Implements IOHandler.

Definition at line 104 of file IOHandlerImpl.cpp.

## doGetName()

const char * IO::IOHandlerImpl::doGetName | ( |  | ) | const

private virtual

Implements IOHandler.

Definition at line 100 of file IOHandlerImpl.cpp.

## doHasMoreInput()

bool IO::IOHandlerImpl::doHasMoreInput | ( | Scanner & | in | ) | const

private virtual

Implements IOHandler.

Reimplemented in IO::NullIOHandler.

Definition at line 96 of file IOHandlerImpl.cpp.

## doReadIdeal()

void IO::IOHandlerImpl::doReadIdeal | ( | Scanner & | in,
|  | InputConsumer & | consumer )

private virtual

Implements IOHandler.

Reimplemented in IO::Fourti2IOHandler, IO::IOHandlerCommon, IO::NewMonosIOHandler, and IO::NullIOHandler.

Definition at line 78 of file IOHandlerImpl.cpp.

## doReadIdeals()

void IO::IOHandlerImpl::doReadIdeals | ( | Scanner & | in,
|  | InputConsumer & | consumer )

private virtual

Implements IOHandler.

Reimplemented in IO::Fourti2IOHandler, IO::IOHandlerCommon, IO::NewMonosIOHandler, and IO::NullIOHandler.

Definition at line 82 of file IOHandlerImpl.cpp.

## doReadPolynomial()

void IO::IOHandlerImpl::doReadPolynomial | ( | Scanner & | in,
|  | CoefBigTermConsumer & | consumer )

private virtual

Implements IOHandler.

Reimplemented in IO::Fourti2IOHandler, IO::IOHandlerCommon, and IO::NullIOHandler.

Definition at line 86 of file IOHandlerImpl.cpp.

## doReadSatBinomIdeal()

void IO::IOHandlerImpl::doReadSatBinomIdeal | ( | Scanner & | in,
|  | SatBinomConsumer & | consumer )

private virtual

Implements IOHandler.

Reimplemented in IO::Fourti2IOHandler, and IO::NullIOHandler.

Definition at line 91 of file IOHandlerImpl.cpp.

## doReadTerm()

void IO::IOHandlerImpl::doReadTerm | ( | Scanner & | in,
|  | InputConsumer & | term )

private virtual

Implements IOHandler.

Reimplemented in IO::CoCoA4IOHandler, IO::Fourti2IOHandler, IO::Macaulay2IOHandler, IO::MonosIOHandler, IO::NewMonosIOHandler, IO::NullIOHandler, and IO::SingularIOHandler.

Definition at line 74 of file IOHandlerImpl.cpp.

## doSupportsInput()

bool IO::IOHandlerImpl::doSupportsInput | ( | const DataType & | type | ) | const

private virtual

Implements IOHandler.

Definition at line 50 of file IOHandlerImpl.cpp.

## doSupportsOutput()

bool IO::IOHandlerImpl::doSupportsOutput | ( | const DataType & | type | ) | const

private virtual

Implements IOHandler.

Definition at line 55 of file IOHandlerImpl.cpp.

## registerInput()

void IO::IOHandlerImpl::registerInput | ( | const DataType & | type | ) |

protected

Specify that input of the argument type is supported.

Definition at line 60 of file IOHandlerImpl.cpp.

## registerOutput()

void IO::IOHandlerImpl::registerOutput | ( | const DataType & | type | ) |

protected

Specify that output of the argument type is supported.

Definition at line 67 of file IOHandlerImpl.cpp.

## Member Data Documentation

## _formatDescription

const char* IO::IOHandlerImpl::_formatDescription

private

Definition at line 73 of file IOHandlerImpl.h.

## _formatName

const char* IO::IOHandlerImpl::_formatName

private

Definition at line 72 of file IOHandlerImpl.h.

## _supportedInputs

vector<const DataType*> IO::IOHandlerImpl::_supportedInputs

private

Definition at line 69 of file IOHandlerImpl.h.

## _supportedOutputs

vector<const DataType*> IO::IOHandlerImpl::_supportedOutputs

private

Definition at line 70 of file IOHandlerImpl.h.

The documentation for this class was generated from the following files:

- src/IOHandlerImpl.h
- src/IOHandlerImpl.cpp